#include <stdio.h>
#include <stdlib.h>

#define MAXDEG   100          //Megistos Va8mos Poluwwnumou
#define MAXITERS 15000        //Megistos ari8mos epanalipsewn
#define ZERO     0.5*10e-8    //Akriveia

typedef struct poly {         //Poluwnumo
    int deg;                  /* Ba8mos*/
    double *coef;             /* Sintelestes*/
}poly;
#include "polyprint.c"        //Anagnwsh poliwnumou
#include "polyread.c"         //Ektipwsi Poluwnunmou
#include "qroots.c"           //Pizes 2-ba8mias ejiswsis
#include "modulo.c"           //Ypoloipo diairesis poluwnumwn
#include "cauchy.c"           //Fragma rizwn Cauchy
#include "sturmseq.c"         //Alisida Sturm
#include "stroots.c"          //Rizes se diastima
#include "stroots2.c"         //Rizes me Sturm kai ipodiairesi
#include "vars.c"             //Allages prosimou
#include "qd.c"               //Rizes me QD
#include "bairst.c"           //Me8odos Bairstow
#include "newton.c"           //Me8odos Bairstow
#include "deflat.c"           //Tetragwnikos Ypovivasmos

int main()
{
    int s;
    double a,b;
    poly P;
    poly* S;

    P=polyread();
    system("cls");
    
    while (1){
    printf("\n\nP(x)= ");polyprint(P);
    printf("\n-----EPILEXTE ENA APO TA PARAKATW:-----\n");
    printf("\n1. EFARMOGH ALGORI8MOY Sturm SE DIASTHMA.");
    printf("\n2. EFARMOGH ALGORI8MOY Sturm GIA PROSEGGISH OLWN TWN PRAGMATIKWN RIZWN.");
    printf("\n3. PROSEGGISH OLWN TWN RIZWN ME TH ME8ODO QD.");
    printf("\n4. PROSEGGISH OLWN TWN RIZWN ME TETRAGWNIKO YPOBIBASMO(Bairstow).");
    printf("\n5. BELTIWSH MIAS RIZAS ME TH ME8ODO Newton-Raphson.");
    printf("\n6. APOTIMHSH POLYWNYMOY SE KAPOIO x.");
    printf("\n7. EISODOS ALLOY POLYWNYMOY.");
    printf("\n0. EXODOS APO TO PROGRAMMA");
    printf("\n\nEPILOGH:"); scanf("%d",&s);
    switch (s)
    {   case 1:
             a=cauchy(P);
             printf("\nCAUCHY!OI RIZES BRISKONTAI STO (-%.2f , %.2f)\n",a ,a);
             S= (poly*)calloc(P.deg+1,sizeof(poly));
             sturmseq(P,S);
             printf("DWSTE TO ARISTERO AKRO(a):");scanf("%lf",&a);
             printf("DWSTE TO DEXI AKRO(b):");scanf("%lf",&b);
             printf("DWSTE PLH8OS DIAMERISEWN(k):");scanf("%d",&s);
             stroots(S,a,b,s);
             free(S);
             break;
        case 2:
             S= (poly *)calloc(P.deg+1,sizeof(poly));
             sturmseq(P,S);
             stroots2(S);
             free(S);
             break;
        case 3:
             qd(P);
             break;
        case 4:
             deflat(P);
             break;
        case 5:
             printf("--- EISAGETE ARXIKH PROSEGGISH ---\nPRAGMATIKO MEROS: ");
             scanf("%lf",&a);printf("MIGADIKO MEROS: ");scanf("%lf",&b);
             newton(P,a,b);
             break;
        case 6:
             printf("DWSTE MIA TIMH: x=");scanf("%lf",&a);
             printf("P(%.2f)=%.2f",a,eval(P,a));
             break;
        case 7:
             free(P.coef);
             P=polyread();
             system("cls");
             break;
       default:
             free(P.coef);
             return 0;
    }
    }
}
