#include <complex.h>
#include "horner.c"

void newton(poly P,double a,double b)
//Proseggisi rizas me ti me8odo Newton, kai arxiki proseggisi a+b*i
{
     int k=1;
     
     complex f,df,w,z= a + b*I;
     
     w=1;
     while ( (fabs(w)>ZERO) && (k++ < MAXITERS) )
     {
           horner(P,z,&f, &df);
           w = f/df;
           z = z - w;
     }

     //Ektipwsi Apotelesmatos
     if (cimag(z)>0)
     printf("\nNEWTON!RIZA: %12.10f + %12.10f*i", creal(z),cimag(z));
     else if (cimag(z)<0)
     printf("\nNEWTON!RIZA: %12.10f - %12.10f*i", creal(z),-1*cimag(z));
     else
     printf("\nNEWTON!RIZA(pragmatiki): %12.10f", creal(z));
}
